










                                   VLF Version 3

                                Software Appliances
                                 52 Bingham Avenue
                            Dedham, Massachusetts 02026


                    Copyright (c) 1986-1989 Software Appliances









                                 TABLE OF CONTENTS


          Section 1:  Introduction.......................................1
          Section 2:  Basic Operation: VLF...............................2
                         Standard options................................5
                              Subdirectories search (/S)
                              Full-volume search (/V)
                              All-volumes search (/A)
                              Wide (packed) display (/W)
                              Pause screen (/P)
                              Help (/H, /?)
          Section 3:  Extended Operation: VLFX...........................7
                         Extended (compressed file) search (/E)..........7
                         Expanded display (/X)...........................8
                         Look at contents (/L)..........................10
                         Filtered search (/F)...........................11
                            Filename Filter.............................14
                            Size Filter.................................17
                            Weekday Filter..............................17
                            Timestamp Filter............................18
                            Date Filter.................................19
                            Time Filter.................................20
                            Attributes Filter...........................21
          Section 4:  Examples..........................................22
          Section 5:  Return Codes......................................26
          Section 6:  Messages..........................................27
          Section 7:  Restrictions, Limits, Hints.......................32
          Section 8:  Technical Information and Revision History........35
          Section 9:  License and Rights................................37




                                   --- Page i ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

                                     SECTION 1

                                    Introduction
                                    ------------


          What is VLF?

               VLF is a DOS command-line utility to find and list files.


          Installation

               You install VLF by copying one or both of the program files
          VLF3xx.COM and VLFX3xx.COM to your operating disk.  Either of
          the programs may be renamed.  VLF is the smaller version; it
          does not search into compressed file archives and lacks the
          Filter, Expand and Look Options, but it is about one-third the
          size of VLFX.  VLFX is the extended version with all options.
          Once copied, the programs are started at the DOS prompt by
          entering

                    VLF<Enter>
                         or
                    VLFX<Enter>


          System Requirements

               You need the following hardware and software to use VLF or
          VLFX:

               IBM PC, PC/XT, PC/AT or any other Intel 8086-compatible
               Any 80-column monitor/adapter with text mode
               About 64K bytes of available memory for VLFX or about 10K
                    bytes of available memory for VLF
               PC/MS-DOS version 2.00 or higher

















                                   --- Page 1 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

                                     SECTION 2

                                Basic Operation: VLF
                                --------------------


          The command format is:

                         VLF  filespec  options

          Filespec is in standard DOS format: dr:\path\filename.ext.
          Wildcards "*" and "?" are handled exactly as in DOS commands
          such as DIR.  If the filespec is omitted, "*.*" is used.  If the
          extension is omitted, an extension of ".*" is assumed; to
          specify the absence of an extension, put a dot (.) at the end of
          the filename.  If only an extension is given, the filespec is
          assumed to be "*" plus the extension given.

          Unlike the DOS DIR command, the last subdirectory in the path
          must end in a "\"; this permits searching for the subdirectory
          entries themselves.  Another way to think of it is that the
          filespec describes a FILE, not a DIRECTORY.  The exceptions are
          the "dot entries" in subdirectories: "." (this directory) and
          ".." (the next higher directory).  These are not files; they are
          navigational aids for DOS.  If a "dot entry" is the final
          directory in the filespec, "\*.*" is added.

          Options are in the format: "/O arg".  The identifier consists of
          a single letter following the slash "switch character".  Each
          option must be preceded by its own switch character, but there
          need not be a separator between options.  Options and their
          arguments may be specified in either upper- or lowercase
          letters.  Option arguments may be adjacent to the identifier or
          separated by any number of separators.  Options may appear
          anywhere on the command line; they do not have to be grouped.
          However, if there are conflicting (mutually exclusive) options
          specified, the last one on the line controls; see the
          descriptions of the options for the conflicts.

          The "switch character" is assumed to be the slash ("/") in this
          manual, but if you change the switch character to something
          else, such as "-", you may use either "/" or "\" to separate
          directory names in the path specification. (The switch character
          can be set with the SWITCH.COM utility, included in this
          package.)









                                   --- Page 2 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------


          The basic display looks like this:


          A: Volume MYDISK_001
          ---------------------
          *Root Dir A:\
          BIGBIO  .COM     9564  Thu  3-07-85  1:43p ARHS
          BIGDOS  .COM    27760  Thu  3-07-85  1:43p ARHS
          ABC          (Subdir)  Wed 10-07-87 11:35p
          COMMAND .COM    23210  Thu  3-07-85  1:43p  R
          CONFIG  .SYS      113  Sun  9-27-87 11:41a
          AUTOEXEC.BAT     1032  Tue  9-29-87 11:37p
              6 Files Found

          ...Subdir A:\ABC
          .            (Self)    Wed 10-07-87 11:35p
          ..           (Parent)  Wed 10-07-87 11:35p
          DEF          (Subdir)  Wed 10-07-87 11:35p
          MYSTIC  .EXE    36307  Tue  1-01-80 12:05p A
          MYSTIC  .ASM    16249  Tue  1-01-80 12:05p A
          ZZ                  0  Fri  2-01-80 12:00a A
              6 Files Found

          ...Subdir A:\ABC\DEF
          .            (Self)    Wed 10-07-87 11:35p
          ..           (Parent)  Wed 10-07-87 11:35p
          ACT     .COM     1223  Wed  6-18-86  4:34p A
          ACT     .ASM    17743  Wed  6-18-86  4:34p A
          ACT2    .ASM    16954  Wed  6-18-86 12:16a
              5 Files Found

           Volume totals for 3 directories
             17 Files Found

            Available:   203776 Bytes in   199 Clusters


          Volume Label:  The heading contains the drive identifier to
          indicate the location of the volume when listed.  If there is no
          label, the heading is "No volume label".

          Directory:  The path and name of the directory precedes the
          listing of files for that directory.

          Filename, Extension:  This is the filename exactly as it appears
          in the directory, except for the explicit dot (.) between
          filename proper and its extension.

          File size:  The displayed file size is a field 9 digits long.
          If the file size is greater than 9 digits, only the rightmost 9
          digits are displayed.


                                   --- Page 3 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

               The "size" field of a directory or a "dot entry" indicates
          the type of directory ("Subdir", "Self", "Parent").

          Day of the Week:  Always listed unless the Wide (W) option is
          requested.

          File Date:  Displayed according to the country code in effect.
          VLF shows the last two digits of the year, so the display for
          1986 is the same as that for 2086.  The day of the week is
          correct in either case.  A null date is displayed as "00-00-80".

          File Time:  Displayed according to the country code in effect.
          If the country code is ambiguous as to the time format (as it
          may be in DOS 2.xx), a 24-hour clock is assumed.  Midnight in a
          12-hour scheme is 12:00 AM, and noon is 12:00 PM.

          Attributes:  Except when the Wide (W) option is on, VLF always
          displays the attributes of the file.  The displayed attributes
          are:

               A    Archive.
               R    Read-only.
               H    Hidden.
               S    System.

               Note: Directory attributes are indicated in the filesize
                    field, as described above.


          After the file listings for each directory, the number of
          matching files is given for that directory.

          Next, if files have been displayed in more than one directory,
          the number of directories in which files were found and the
          total number of files are displayed.

          At the end of each volume's listings, the amount of unallocated
          disk space is displayed, expressed both as a number of free
          bytes and as a number of free clusters.

          If there are listings in more than one volume, VLF adds totals
          for the number of directories and files.












                                   --- Page 4 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

          Options
          -------
          Options supported in this version are:

          /S   Subdirectories Search
               Starting with the specified directory (or the current
               directory if none is specified), search it and all its
               subdirectories.  Supersedes any prior /V or /A options.

          /V   Full-volume Search
               Starting with the root directory, search it and all the
               subdirectories on the disk.  This is identical to the /S
               option with the root directory specified as the starting
               path.  The path is ignored if present.  Supersedes any
               prior /S or /A options.

          /A   All-volumes Search
               Starting with the root directory of Drive A, search all
               directories in all volumes of the system.  The drive and
               path are ignored if present.  If one of the floppy drives
               is not ready (no disk, door open, etc.), VLF prints the
               message "Cannot access Drive X" and goes on to the next
               drive.  Supersedes any prior /V or /S options.

          /Wn  Wide (Packed) Display
               Controls the number of filename entries on each line.  "n"
               may be any single digit or may be omitted; if omitted, 2 is
               assumed.  The following lists the fields displayed for each
               value of "n":

                    0 - Cancels /W (1 entry per line, standard display)
                    1 - Same as 0.
                    2 - Filename, size, date, time
                    3 - Filename, date
                    4 - Filename
                    5 - Filename
                    6 thru 9 - Value set to 5

               Supersedes any prior /X or /L options.

               /W finds its argument "n" by checking the next non-
               separator character to see whether it is a numeral.  If
               non-numeric, "n" is absent; if numeric, it is taken to be
               "n".  You should be careful that /W does not mistake a
               trailing filespec that starts with a numeral for the
               argument.  Options can be placed anywhere on the command
               line, however; so you avoid any problem by placing /Wn
               following the filespec.






                                   --- Page 5 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

          /P   Pause Screen
               VLF stops the screen output every 24 lines, prints the
               message

                    "Strike any key to continue ..."

               and waits for any key in response.  The pause message stays
               on the screen and is the topmost line of the next full
               screen.  The response key is taken from the standard input
               device after clearing out the keyboard buffer, so if you
               respond with a key that delivers a two-character "extended
               code", such as a function key or a cursor key, the second
               half of the code will not be read as a response the next
               time VLF pauses.  However, this also means that you cannot
               feed characters from a keyboard stack.

          /H and /?  Help
               VLF displays a copyright notice and a list of options on
               the standard output device and exits to DOS.



































                                   --- Page 6 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

                                     SECTION 3

                               Extended Options: VLFX
                               ----------------------

          VLFX includes all the features and capabilities of VLF.  In
          addition, there are four options available only in VLFX:
          Extended search (E), Expanded display (X), a Look at the
          contents (L), and the Filtered search (F).


          /E   Extended Search
          --------------------

          /E causes VLFX to look into all compressed file archives (files
          with the filename extension "ARC" or "ZIP") for compressed files
          that match the search criteria.

          When VLFX finds a matching compressed file, it displays the
          archive file information to identify the external file holding
          the match, prints a separator line, then lists the compressed
          file and closes with another separator line.

          Only files with the extension "ARC" or "ZIP" are considered
          archives.  If the data in an ARCfile or ZIPfile doesn't match
          the standard format for that archive, it is simply ignored; VLFX
          closes the file and goes on.

          The count of files found will include the number of compressed
          files, but not the archive itself, UNLESS the archive also
          matches the search criteria.

          The Extended Display (/X) option includes the size of the entire
          archive in the aggregated size of files.  The file allocation
          (cluster-chain) is given for the archive, but not for the
          individual compressed files.

          The Filtered Search (/F) option applies the filter to compressed
          files if /E is specified.  For the purposes of the filter, each
          compressed file in an ARCfile is taken to have the same
          attributes as the archive, since its own attributes were lost
          when it was archived.  You should note also that all compressed
          files in ZIPfiles have the Archive attribute set to ON, although
          the remainder of the attributes are preserved.










                                   --- Page 7 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

          /X   Expanded Display
          ---------------------
          /X adds the cluster allocation list, the volume creation date,
          the total size and cluster allocation of all files found, and a
          space efficiency percentage for those files.  Supersedes any
          prior /W or /L option.

          The display with /X on:


          A: Volume MYDISK_001   Wed 1987-10-07 23:38:32
          ---------------------
          *Root Dir A:\
          BIGBIO  .COM     9564  Thu 1985-03-07 13:43:00 ARHS A:2-11
          BIGDOS  .COM    27760  Thu 1985-03-07 13:43:00 ARHS A:12-39
          ABC          (Subdir)  Wed 1987-10-07 23:35:02      A:40
          COMMAND .COM    23210  Thu 1985-03-07 13:43:00  R   A:42-64
          CONFIG  .SYS      113  Sun 1987-09-27 11:41:46      A:65
          AUTOEXEC.BAT     1032  Tue 1987-09-29 23:37:26      A:66-67
              6 Files:    61679 Bytes in    65 Clusters (94%)

          ...Subdir A:\ABC
          .            (Self)    Wed 1987-10-07 23:35:02      A:40
          ..           (Parent)  Wed 1987-10-07 23:35:02      A:
          DEF          (Subdir)  Wed 1987-10-07 23:35:08      A:41
          MYSTIC  .EXE    36307  Tue 1980-01-01 12:05:32 A    A:68-103
          MYSTIC  .ASM    16249  Tue 1980-01-01 12:05:32 A    A:104-119
          ZZ                  0  Fri 1980-02-01  0:00:00 A    A:
              6 Files:    52556 Bytes in    53 Clusters (99%)

          ...Subdir A:\ABC\DEF
          .            (Self)    Wed 1987-10-07 23:35:08      A:41
          ..           (Parent)  Wed 1987-10-07 23:35:08      A:40
          ACT     .COM     1223  Wed 1986-06-18 16:34:56 A    A:120-121
          ACT     .ASM    17743  Wed 1986-06-18 16:34:56 A    A:122-139
          ACT2    .ASM    16954  Wed 1986-06-18  0:16:20      A:140-156
              5 Files:    35920 Bytes in    37 Clusters (95%)

           Volume totals for 3 directories
             17 Files:   150155 Bytes in   155 Clusters (96%)

            Available:   203776 Bytes in   199 Clusters


          The year format is always YYYY-MM-DD and the time format is 24-
          hour HH:MM:SS to show the exact values and to permit sorting by
          date and/or time with a single key (as the DOS sort filter
          requires).

          The file allocation chain is listed at the far right of each
          line, preceded by the drive designation.  The numbers are
          "logical cluster" numbers, i.e. the first data cluster is 2.  If
          the drive has been reassigned with the DOS commands ASSIGN, JOIN

                                   --- Page 8 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

          or SUBST, the drive ID for the allocation chain will indicate
          the actual ("physical") drive location of the file.  No
          allocation display is possible for compressed files; instead,
          the allocation of the containing archive is shown.

          With the file count for each directory, volume or the system, /X
          displays the aggregated size of the listed files, the number of
          clusters they occupy, and the percentage of data clusters
          actually occupied by data.  For compressed files, the statistics
          that are added to the aggregates are those of the archive
          itself.  If the efficiency of a group of files is less than 80%,
          you should consider strategies to attach some files together.










































                                   --- Page 9 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

          /L  Look
          --------
          The format is

               /L nnn

          The /X option is set on and the first "nnn" bytes of each file
          is displayed (excluding zero-length files).  "nnn" may be in the
          range 1 to the sector size (almost universally 512); if no
          number is specified, 80 bytes are displayed.  If "nnn" is
          greater than the sector size for the disk, it is reduced to the
          sector size; so if you apply /L to files on disks with different
          sector sizes, you should specify "nnn" as the largest.  If "nnn"
          is zero, /L is canceled, but /X remains on.  Supersedes any
          prior /W option.

          The display is crudely formatted; all carriage returns (ASCII
          13) and line feeds (ASCII 10) cause a new line.  ASCII values 0
          (null), 7 (bell), 8 (backspace), and 27 (escape) are represented
          by a dot (.); all other control characters (ASCII 0-31) and all
          extended characters (ASCII 128-255) are displayed as themselves.
          The file characters are displayed between two lines of all
          dashes (-) for readability.

          Because /L assumes that the first non-separator character
          following the "/L" is the start of the character count, you
          should be careful that VLFX does not mistake a filespec that
          starts with a numeral for its character count.  Options can be
          placed anywhere on the command line, however; so you avoid any
          problem by placing /L following the filespec.

          /L, although limited, can help catalog a disk.  If pertinent and
          readable information is included in the first 512 bytes, a
          listing of files with the /L option on, redirected to a file or
          the printer, will provide a record of the absolute location of
          the file (the allocation chain) and its contents.


















                                  --- Page 10 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

          /F   Filtered Search
          --------------------
          /F selects for display only those files that satisfy both the
          filespec and all the specified conditions.  Any characteristics
          that appear in the directory can be filtered:

               Filename
               File size
               Day-of-the-week of timestamp
               Timestamp (date and time)
               Date of timestamp
               Day-of-the-month of timestamp
               Month of timestamp
               Year of timestamp
               Time-of-day of timestamp
               Hour of timestamp
               Minute of timestamp
               Seconds of timestamp
               File attributes

          Each of these filter conditions has its peculiarities and rules.
          The rules that apply to all are discussed first.


          The general format for the filter is

                    /F (condition boolean condition ...)

          where "condition" consists of "type operator value" and
          "boolean" is one of the logical operators AND, OR, and NOT.


          "Type" is one of the following:

               Name      Min Abbr  Description
               ----      --------  -----------
               FILENAME  F         filename proper and extension
               SIZE      SI        filesize
               WEEKDAY   W         day-of-week of the file date
               STAMP     ST        timestamp (both date and time)
               DATE      D         date
               TIME      T         time-of-day
               ATTRIBUTE A         attributes











                                  --- Page 11 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

          "Operator" is one of the following relational operators.:

               Name      Min Abbr  Description
               ----      --------  -----------
               EQ        EQ        equal to
               NE        NE        not equal to
               GT        GT        greater than
               GE        GE        greater than or equal to
               LT        LT        less than
               LE        LE        less than or equal to

          If the relational operator is omitted, EQ is assumed.  None of
          the relational operators may be abbreviated.


          "Value" is the target operand.  See the explanation of each
          filter type for the format and range of its value.


          "Boolean" is a logical operator.  The logical operators
          recognized are:

               Name      Min Abbr  Description
               ----      --------  -----------
               AND       AN        logical and (if both are TRUE, the
                                        expression is TRUE)
               OR        O         logical or (if either is TRUE, the
                                        expression is TRUE)
               NOT       N         logical not (if FALSE, the expression
                                        is TRUE)

          If the logical operator is omitted, AND is assumed.  Although
          the logical operators may be abbreviated, the readability of the
          expressions suffers; it is recommended that you not only enter
          them in full but also enter them in upper case.  The following
          are equivalent filters:

               /F NOT  (DATE EQ TODAY  AND  TIME LT NOW)
               /f not (date eq today   time lt now)
               /F NO (DATE EQ TODAY, TIME LT NOW)
               /f no(date today,time lt now)
               /F N(D TODAY,T LT NOW)

          The NOT operator is the same as the combination AND and NE, so
          the following are equivalent:

               /F  DATE NE 12-25-86
               /F  AND  DATE NE 12-25-86
               /F  NOT  DATE EQ 12-25-86
               /f  not (date 12-25-86)
               /f  AND ( NOT  DATE 12-25-86 )



                                  --- Page 12 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

          The Boolean operators should not be used immediately adjacent to
          each other (e.g. AND NOT, OR NOT); only the last in sequence
          will be recognized.


          There may be any number of conditions, subject to the DOS
          limitation of 127 characters for command line parameters.
          Conditions may be nested to any level up to 255.  The entire
          filter is evaluated left-to-right and all the logical operators
          are left-associative; that is, each logical operator combines
          the current status (TRUE/FALSE) of all the expressions to the
          left with the status of the expression immediately to the right.
          So the filter expression

               /F (DATE EQ TODAY  AND  TIME LT NOW  OR  ATTR A)

          is evaluated as

               /F ( (DATE EQ TODAY  AND  TIME LT NOW)  OR  ATTR A)

          To override that order, use parentheses, as in

               /F (DATE EQ TODAY  AND  (TIME LT NOW  OR  ATTR A) )

          If the filter is made up of more than one condition, the entire
          set of filter expressions MUST be enclosed in parentheses.  But
          it is OK to omit the parentheses in a single-condition filter,
          so the following are equivalent:

               /F (SIZE GT 4000)
               /F  SIZE GT 4000

          Except as may noted below in the descriptions of the specific
          filter conditions, any of the elements may be separated by one
          or more of the valid command line separators (the DOS manual
          calls them "delimiters"): space, tab (ASCII 9), equal (=), comma
          (,) or semicolon (;).  All conditions must be separated by at
          least one separator or by parentheses, so the following are OK:

               /F (filename "050" and stamp gt today-2)
               /F ((filename "050")and(stamp gt today-2))
               /F ((filename "050")(stamp gt today-2))

          but the next is not:

               /F (filename "050"stamp gt today-2)

          All elements may be in uppercase or lowercase or a mix.  Each
          filter type name and logical operator may be abbreviated to the
          minimum needed to differentiate it (see the explanation of the
          Attribute filter, though).



                                  --- Page 13 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

          The filter is applied to compressed files in an archive whenever
          the Extended Search (E) option is specified.  Note that
          compressed files in an ARCfile have no file attributes, so each
          is assumed to have the attributes of the containing archive
          file; also that those in a ZIPfile always have the archive
          attribute ON.



          Filename Filter
          ---------------
          The Filename filter uses the UNIX-style "regular expression"
          conventions to specify a text pattern that is matched to the
          filenames found in the DOS search for the filespec.

          The format of the Filename filter is

                    FILENAME "regular-expression"

          The only valid relational operators are EQ and NE.

          The filename string that is matched with "regular_expression" is
          "packed"; that is, there are no embedded blanks between the
          filename proper and the extension.  If there is an extension, it
          is separated from the name by a dot (period); if there is no
          extension, there is no dot.  This last qualification makes it
          awkward to match an ending of the filename proper, but it can be
          done.  See the examples.


          The regular expression syntax is arcane, but it is exacting and
          a standard.  This version of VLFX implements nearly the complete
          "limited regular expression"; the main exceptions are the lack
          of a repetition capability for entire groups -- that is, only
          single characters may be repeated -- and the lack of a "one or
          more" repetition special character.  The special (control)
          characters are not the same as in most implementations of UNIX
          itself.  Also, a special character has been added -- one or none
          single character -- that is particularly useful for very short
          strings, such as filenames.

          In the regular expression itself, the following characters have
          special meaning:

               DOUBLE-QUOTE (") delimits the match pattern, both the
          beginning and the end.  DOS will ignore the special DOS meaning
          of any character enclosed in double-quotes on the command line,
          so the bar (|) and the angle-brackets (<>) can be safely used in
          the match pattern.

               ASTERISK (*) matches none or any number of any characters.
          "a*e" matches "ae", "Garden", "ACE".


                                  --- Page 14 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

               QUESTION MARK (?) matches exactly one of any character
          which MUST be present for the match.  "a?e" matches "abe" and
          "ACE" but neither "ae" nor "abce"

               SINGLE-QUOTE (') matches none or one of any character; a
          character need not be present for a match.  "a'e" matches "ae"
          and "Abe" but not "abce".

               AMPERSAND (@) matches none or any number of the preceding
          character, that is, a "repetition".  In this version of VLFX,
          the character must be a single character (not a group), but may
          be either a specific character or a character set.  The
          character may not be a special control character such as "?"
          (although the same effect is had with "*").  "ab@e" matches
          "ae", "ABE", and "abbey", but neither "ace" nor "abce".

               BRACKETS ([]) define a character set that represents a
          single character.  The set matches a character if any member of
          the set matches the character.  The set may be inclusive or
          exclusive; an exclusive set is denoted with a tilde (~) in the
          first position and will match any character NOT in the set.
          Within the set a consecutive range of characters can be
          designated by a dash (-).  There cannot be a null set; that is,
          "[]" and [~]" are flagged as errors.  Since the set cannot be
          null, the close-bracket (]) immediately following the open-
          bracket represents itself and has no special meaning; thus "[]]"
          and "[~]]" are sets that include and exclude only the close-
          bracket character (]).  Similarly, the pattern "[~-]" describes
          a set that excludes only the dash (-).  Of course, both the
          close-bracket and the dash can be explicitly designated as
          themselves with the "escape" character "\"; thus, "[abc0-9\]]"
          and "[a\-z]" treat the "\]" as a regular character "]".  "[a-z0-
          9]" matches any letter or number.  "[~1234567890]" matches any
          character not a number.  "[\000-\0ff]" matches any character and
          is the equivalent of "?".

               TILDE (~) makes a character set exclusive; that is, the set
          matches only if NO member of the set matches.  However, the
          tilde has this special meaning only if it is the first character
          in the set; otherwise, it is a regular character and matches
          itself.

               DASH (-) in a character set defines an inclusive range of
          members.  The ends of the range are more easily read if the
          lower end is given first ([a-z]) but it is not necessary; "[a-
          z]" and "[z-a]" are equivalent.  If a dash cannot be interpreted
          as defining a range it may be used without escape, so in the
          patterns "[-zZ]" and "[0-9-z-a] the dash preceding the "z"
          represents itself.

               PARENTHESES (()) define a group of characters or
          expressions.  The main use of the group in this version is to
          define alternative groups, separated by a bar (|).  If any of

                                  --- Page 15 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

          the alternate groups match, the entire set of alternate groups
          match.  Alternate expressions MUST be enclosed in parentheses,
          although if there is no ambiguity the "internal" parentheses may
          be omitted; thus "(a)|(b)" may be entered as "(a|b)", but "a|b"
          does not define alternates and the bar is treated as a regular
          character.  There may be more than two alternates, as in
          "(ab)|(cd)|(ef)".  Each group may contain one or more groups, as
          in "(a(bc)|(de(f)|(g))hij)|(klm)".  A null group is allowed, so
          "a(b|c|)e" matches "abe" or "ace" or "ae".

               BAR (|) matches either the preceding or the following
          group.  Unlike some implementations of regular expressions, the
          first of the alternative groups must be explicitly defined by an
          open-parenthesis (() and the last by a close-parenthesis ()),
          even if the groups are single characters.  A bar not following
          an open-parenthesis is treated as a regular character, so
          "(a)|(b)" matches "a" or "A" or "b" or "B", but "a|b" matches
          only "a|b" or "A|B".  If there can be no ambiguity, the
          parentheses adjacent to the bar may be omitted, as in
          "(ab|bc|cd)"; this abbreviation should be reserved for only the
          simplest expressions.

               LESS-THAN (<) matches the beginning of the name; that is,
          the pattern matches only if it occurs at the very beginning of
          the name.

               GREATER-THAN (>) matches the end of the name; that is, the
          pattern matches only if it occurs at the very end of the name.

               BACKSLASH (\) is the escape character.  It removes the
          special meaning from any of the above characters and confers
          special meaning to the otherwise regular characters described
          below.  Used before any other character, it has no effect.  The
          only way to enter a backslash into the match pattern as itself
          is to remove its special meaning by preceding it by another
          backslash, thus - "\\".

          The following are not valid characters in filenames but are
          included here for completeness in describing the regular
          expression conventions.

               \t matches the tab character (ASCII 9 or HT).  The "t" must
          be lowercase.
               \r matches the carriage return character (ASCII 13 or CR).
          The "r" must be lowercase.
               \n matches the line-feed character (ASCII 10 or LF).  The
          "n" must be lowercase.
               \b matches the backspace character (ASCII 8 or BS).  The
          "b" must be lowercase.
               \f matches the form-feed character (ASCII 12 or FF).  The
          "f" must be lowercase.



                                  --- Page 16 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

               \0hh matches the character represented by the two
          hexadecimal digits hh.  The hex digits may include either lower-
          or uppercase letters.  "\000" is the only way to enter the NULL
          character (ASCII 0) into the match pattern.  "\012" is identical
          to "\f" (the FF character).  However, "\05C" is not the escape
          character but the backslash; it is equivalent only to "\\".



          Size Filter
          -----------
          The Size filter matches the size of the found files with a
          target value.

          The format of the Size filter is

                    SIZE  op  nnnn

          All relational operators are valid.

          The target value "nnnn" must be numeric and must not be larger
          than 4,294,967,295, the largest number that can be represented
          by a 32-bit unsigned binary integer.  Zero is an acceptable
          size; all subdirectory and directory pointer (so-called "dot
          files") entries have filesizes of zero, as do files that have no
          data space assigned.  (A file that has been opened but not
          closed has a filesize of zero.)



          Weekday Filter
          --------------
          The Weekday filter matches the day-of-the-week of the found
          files' dates with the day given.

          The format of the Weekday filter is

                    WEEKDAY  op  day

          All relational operators are valid.  For this purpose note that
          the DOS convention assigns Sunday the numerical value zero and
          Saturday the value six, so the match for the weekend days
          Saturday and Sunday has to be

               (WEEKDAY EQ SUN  OR  WE EQ SAT)
               (WEEKDAY LT MON  OR  WE GT FRI)








                                  --- Page 17 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

          The acceptable weekday names, not surprisingly, are

               SUNDAY         (value 0)
               MONDAY         (1)
               TUESDAY        (2)
               WEDNESDAY      (3)
               THURSDAY       (4)
               FRIDAY         (5)
               SATURDAY       (6)

          The weekday may be abbreviated but must be a minimum of two
          characters.



          Timestamp Filter
          ------------
          The Timestamp filter matches the timestamp of the found files
          with a specified date and time.

          The format of the Timestamp filter is

                    STAMP  op  date +/- modifier  time +/- modifier

          All relational operators are valid.

          The date may be entered in one of three forms:

               Numeric:       mm-dd-yy
               Symbolic:      TODAY
               Correspondent: filespec

          The numeric date must be in the format of the country code in
          effect at the time in DOS.  For the USA (country code 001) the
          format is as shown above; the date separator is a dash (-).
          Each field must be null or numeric; if null, the field is
          assumed to be zero.  Trailing fields may be omitted; if they
          are, they are set to zero.  The mm field must be in the range 0-
          12; dd 0-31; yy 80-99 for the 1980-1999, 00-79 for 2000-2079, or
          any four-digit number 1980-2099.  Note that the only way to
          specify a year beyond 2079 is to use all four digits.  Zero is
          permitted for the month and day values, even though it does not
          actually describe a date, in order to match a DOS dateword of
          binary zero, logically the date 00-00-1980.  The maximum value
          for the day field is not adjusted for the month, so the date 2-
          30-86 is allowed and will match above 2-28-86 and below 3-1-86.

          The symbolic date "TODAY" uses the current date from DOS.
          During a single run of VLFX "TODAY" is retrieved from DOS only
          once, so that it has a constant value throughout the filter.




                                  --- Page 18 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

          The third way to specify the date is to use the date from an
          already existing file, a key file or master file.  The
          "filespec" is in standard DOS format and may include a drive
          letter and a directory path.  NOTE: since numerals, the
          parentheses "(" and ")" and the minus "-" are valid in
          filenames, you may optionally enclose the filespec in double-
          quote (") characters; VLFX will use everything between the
          quotes as the filespec.

          Similarly, the time may be entered in one of three forms:

               Numeric:       hh:mm:ss
               Symbolic:      NOW
               Correspondent: filespec

          The numeric time must be entered in the international 24-hour
          format, but with the time separator of the country code in
          effect at the time in DOS.  For the USA (country code 001) the
          format is as shown above; the time separator is a colon (:).
          Each field must be null or numeric.  hh must be in the range 0-
          23; mm 0-59; ss 0-59.  Midnight is represented as 00:00:00, not
          24:00:00.

          The symbolic time "NOW" uses the current time from DOS.  As with
          the symbolic "TODAY", during a single run of VLFX "NOW" is
          retrieved from DOS only once, so that it has a constant value
          throughout the filter.

          The third way to specify the time is to use the time from an
          already existing file.  See the discussion above.

          Both the date and the time may take a "modifier", a numeric
          value that is added to or subtracted from the specified date or
          time.  The date modifier is always days, the time minutes.  No
          separator is necessary between the +/- and the date or between
          the +/- and the modifier, but take care that there is no
          confusion between the date separator "-" and the minus.  The
          date modifier may have a value from 0 to 43830, the number of
          days from 00-00-1980 to 12-31-2099, but it is an error for the
          date to be decremented below 00-00-1980 or incremented above 12-
          31-2099.  Similarly, the time modifier may have a value from 0
          to 1440, the number of minutes in a day.  If the time is
          decremented below 00:00, it wraps around to 23:59; similarly, if
          the time is incremented beyond 23:59, it wraps around to 00:00;
          but in neither case is the date affected.  Because the time
          modifier is in minutes, the seconds field of the time is not
          affected in any way by the modifier.







                                  --- Page 19 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------




          Date Filter
          -----------
          The Date filter matches the timestamp date of the found files
          with a specified date.

          The format of the Date filter is

                    DATE  op  date +/- modifier

          All relational operators are valid.

          The date specification differs from that in the Timestamp filter
          above only in that null and omitted fields of numeric dates are
          ignored in the match, so that

               date ge 8
               date ge 8-
               date ge 8--

          match all dates of August through December, regardless of the
          day of the month or the year, and

               DA -1-87
               DA -1-87

          match all files created or modified on the first of any month in
          the year 1987.

          The date modifier can be used with such "partial" numeric dates.
          For the purposes of modification calculation, the omitted fields
          are zero, so

               dat  eq  7 +31
               dat  eq  6 +31
               dat  eq  8 -1

          match any date in July.  The day and year are still ignored.



          Time Filter
          -----------
          The Time filter matches the timestamp time of the found files
          with a specified date.

          The format of the Time filter is

                    TIME  op  time +/- modifier

          All relational operators are valid.

                                  --- Page 20 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------


          The time specification differs from that in the Timestamp filter
          above only in that null and omitted fields of numeric times are
          ignored in the match, so that

               time  ge  14
               time  ge  14:
               time  ge  14::

          match all times from 2:00p until midnight, regardless of the
          minutes or seconds, and

               TIM GT :30
               TIM GT :30:

          match all files created or modified in the second half-hour of
          any hour.

          The time modifier can be used with such "partial" numeric times.
          For the purposes of modification calculation, the omitted fields
          are zero, so

                    time  eq  17 +59
                    time  eq  16 +60
                    time  eq  18 -1

          match any time in the hour from 5:00p to 5:59p.  The minutes and
          seconds are still ignored.



          Attributes Filter
          -----------------
          The Attributes filter matches the attributes of the found files
          with specified attributes.

          The format of the Time filter is

                    ATTRIBUTES op attribute-list

          The minimum abbreviation should be "AT".  Actually the
          abbreviation "A" will work in most cases, but there are two
          other elements that start with "A" -- LOGICAL AND and attribute
          "archive" -- so for readability and reliability, your practice
          should be to use "AT".

          The only valid relational operators are EQ and NE.

          The attribute list is a string of letters representing the
          attributes that MUST match; no blanks are allowed in the list.
          You should think of the list as attributes ANDed together; that
          is, ALL of the attributes listed must be set in order to match.


                                  --- Page 21 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

          The list may contain any of the following:

               A    archive
               R    read-only
               H    hidden
               S    system
               D    directory
               N    none (or normal)

          It is an error to combine "N" and any other attribute in the
          same list; any other combination is valid, although it would be
          bizarre to find a directory with an archive attribute.










































                                  --- Page 22 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

                                     SECTION 4

                                      Examples
                                      --------

          1.  If you need to find a file or set of files with the name
          "ABCD", regardless of extension, these all will do it.

               vlf/v abcd
               vlf abcd.* /v
               vlf \abcd /s
               vlfx/v abcd
               vlfx/e/v abcd.???   (also searches archives)

               These are the classic "where-is" commands, searching the
          whole current disk for all the files with the filename "ABCD",
          with or without an extension.


          2.  If you just want to list the contents of the current
          directory, all these are equivalent.

               vlf
               vlfx
               vlf *.*
               vlf .
               vlf .\*.*
               vlfx /ff "*"
               vlfx/e .\           (also lists contents of archives)


          3.  If you want to see EVERY file on-line in the system, use /A.

               vlf /w5/a/p

               This command produces a screen listing of all files current
          on the system, with pauses for each full screen.  The files are
          listed five per line (filenames only).


          4.  In order to list all the files, including directories, in
          the directory "above" the current directory ("parent"
          directory), use these.

               vlf ..
               vlfx ..
               vlf ..\
               vlf ..\*.*

               If the current directory is the root directory, these
          commands will return errors, since there is no higher-level
          directory.


                                  --- Page 23 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------


          5.  If you need to list all the files in the current directory
          of Drive B: that have the extension "COM", and you want to make
          sure none scroll off the top of the screen before you see them,
          use the /P switch.

               vlf b:*.com /p
               vlf/p b:.com
               vlfx/p/ff ".com" b:


          6.  If you come in on Monday morning and want to see what files
          have changed since you left on Friday at 5 o'clock, either of
          the following will show them to you.

               vlfx /fstamp gt today-2 17:00
               vlfx /f ((date today-2 AND time gt 17) OR date ge today-1)


          7.  Say you want to update a semi-permanent listing of all the
          "DOC" files you are working on, all those that have changed in
          the last month.  Each file has a 256 byte ID record at the
          beginning, so you would like to include that in the listing.
          The following will do it in one pass.

               vlfx c:r*.doc /v /f date ge today-30 /l=256 >>a:doclist

               This command searches the entire Drive C for all .DOC files
          starting with "R", but only those with file dates within the
          last 30 days are listed.  Following each entry the first 256
          bytes are displayed for cataloguing.  The entire listing is
          appended to file DOCLIST in the current directory of Drive A:.


          8.  When you need to see how fragmented are the files in a
          certain subdirectory chain, use /X and /S.

               vlfx/s/x/fsize gt 2048 c:\wp\doc\

               This command finds all the files in the subdirectory
          \WP\DOC and the subdirectories belonging to it, but displays
          only those that are bigger than a single (4-sector) cluster,
          since zero-length and single-cluster files are not fragmented.
          The display includes the cluster allocation chain for each
          listed file.









                                  --- Page 24 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

          9.  If you want to display all files whose filename proper ENDS
          in "123", whether or not there is an extension, the following
          Filename filter will do.

               vlfx /f filename "<[~.]@123(>|.)"

          The expression means: match the string "123" with no dot between
          it and the beginning of the name (i.e. not in the extension),
          where the string is at the end of the name or is the last string
          before a dot.


          10.  If you want to find all files whose names contain the
          number "050" and have extensions, as opposed no extensions, the
          following Filename filter does it.

               vlfx /f fil "050*."

          The expression means: match the string "050" anywhere in the
          filename prior to a dot, which must be present.  Recall that the
          filename returned by DOS contains the dot separator between a
          filename proper and the extension only if an extension is
          present.  Therefore, any name that has no dot (no extension)
          does not pass the filter.


          11.  If you would like to see which spreadsheet work files on
          the hard disk have been changed or created since the last backup
          run, use a filter to check the "archive" attribute.

               vlfx/v  c:*.wk?  /f attr a

          This command finds all the "WKx" files on Drive C: and displays
          those with the archive bit on.


          12.  If you are running with a hard disk that was set up under
          DOS 2.xx (4-8K clusters) and are wondering how much space you
          might release by re-partitioning under DOS 3.xx (2K clusters),
          first find all the files that would fit into a single 2048 byte
          cluster, then check the space efficiency of some other small
          files with a filter and /X.

             vlfx/v /f (size le 2048 AND size ne 0)
             vlfx/v/x /f((si gt 2048,si le 3072)OR(si gt 4096,si le 7168))

          The first command lists those files that are wasting 2KB apiece
          under DOS 2; the second command lists those 4K and 8K files that
          waste at least 1KB each.





                                  --- Page 25 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

          13.  If your batch file needs to check for the existence of a
          file in a multi-directory search (IF...EXIST won't do it), use
          VLF and test the return code.

             vlf/v date.ck >nul
             if errorlevel 2 goto error_exit
             if errorlevel 1 goto not_found
             :ck_ok

          If the file DATE.CK exists, the return code will be zero; if
          not, it will be one.  The check for a return code higher than
          one assures that there was nothing else abnormal about the VLF
          search.  If you redirect the output of VLF to the "NUL" file,
          there will be display, but the return code will be set
          correctly.







































                                  --- Page 26 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

                                     SECTION 5

                                    Return Codes
                                    ------------

               VLF/VLFX

               0 = Normal return.  At least one matching file was found.
                    VLF has exited normally.

               1 = Not found.  There were no matches found.  VLF has
                    exited normally.

               Greater than 1 = Abnormal exit.  VLF has detected an error
                    either while scanning the parameters or during
                    operation and has exited with an error message.


               IOCTL

               If setting mode, 0 = success return
               If displaying mode, 0 = ASCII mode; 1 = Binary mode
               255 = invalid parameter


               SWITCH

               Always returns 0.


























                                  --- Page 27 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

                                     SECTION 6

                                      Messages
                                      --------

          The following are the un-normal messages from VLF.  Except for
          those designated "(Std Out)", these messages are always sent to
          the Standard Error Device, the main console/screen; since (for
          better or for worse) DOS does not permit the either the
          reassignment or redirection of the Std Err, you will have visual
          notice of errors even when you redirect the regular output.

          "** Cannot access Drive X:"
                    The /A option is on, and drive X: does not respond
               because, for example, there is no disk inserted or the door
               is open.  VLF continues to the next drive.  Occasionally,
               you may get this message even though the drive is loaded;
               some drives are slow to cycle up and will sometimes fail to
               get up to speed within the standard three tries; just try
               again.

          "Cannot recognize condition in filter"
                    While scanning the Filter option, VLFX got to a point
               where it expected to find a filter specification but
               instead found either a text string that it did not
               recognize as a filter type or the end of the command line.
                    Examples: vlfx /f
                              vlfx /f/x
                              vlfx /f s 1000

          "Cannot rep a special character in name filter"
                    A repetition character (@) follows a control character
               that cannot be repeated.  If the "@" is meant to be itself,
               i.e. not the repetition character, it must be preceded by
               the escape character (\).
                    Examples: vlfx/ff  "(a|b)@"
                              vlfx/ff  "(a|@b)"

          "**Can't search DR:\PATH\FILENAME.ZIP" (Std Out)
                    The named archive file can't be opened for reading.
               Probably the file is locked (in use by another program).
               VLFX has just gone on to the next file.

          "Expected alternate group in name filter"
                    VLFX found the LOGICAL OR character (|) that separates
               alternate groups, but was unable to recognize an adjacent
               alternate group.
                    Examples: vlfx /ff  "a(a|b|)|"
                              vlfx /ff  "a(a|b|)|a"





                                  --- Page 28 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

          "Extra characters on command line ignored"
                    VLF has processed the filespec and all options, but
               there are still more non-separator characters on the
               command line.  VLF continues, but this is a warning that
               you may not have gotten what you wanted from the command.
               For example, you may have forgotten to put a switch
               character (\) before an option, or you may have specified a
               multi-expression filter without enclosing it in parentheses
               (only the first expression is used).  Remember, too, that
               VLF stops scanning the filespec whenever it comes upon a
               character that is illegal for a filename.
                    Examples: vlf *.* /ps
                              vlfx fil*. /f si gt 200 si lt 4000

          "File not found in (stamp, date, time) filter"
                    The file with the implied date or time value cannot be
               found by DOS.  Make sure that you don't have special
               characters in the filename that confuse VLFX.
                    Examples: vlfx /FD fil-01.tmp (quotes needed)
                              vlfx /FD \w*rk\fil.001 (invalid path)

          "Insufficient memory"
                         Although the program loaded properly, it was
               unable to get enough allocated memory from DOS to run.

          "Invalid combination in attribute filter"
                    The attribute "N" (none or "normal") was specified
               along with some other attribute.
                    Examples: vlfx /fattr na

          "Invalid (day, month, year) field in (stamp, date) filter"
          "Invalid (hour, minute, seconds) field in (stamp, time) filter"
                    The field in the explicit (numeric) date or time value
               is either not numeric or is too large or too small.
                    Examples: vlfx /f stamp eq fil0000 24:10
                              vlfx /f date eq 01-w1-87
                              vlfx /f stamp eq 01-01-198 08:30:00

          "Invalid day in weekday filter"
                    The day value is not recognized as the name of a
               weekday.
                    Examples: vlfx /fw tesday (typo)
                              vlfx /fw eg tuesday ("eg" taken as the day)

          "Invalid directory"
                    One of the directories in the specified path is not
               recognizable or not found by DOS.  Also, this is the
               message for a specified path too long for DOS to work with.
                    Examples: vlf \wrk*\*
                              vlf \work\..\.. (no parent to Root dir)




                                  --- Page 29 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

          "Invalid drive"
                    The drive specified with the filespec is not valid on
               this machine.
                    Examples: vlf g:\abc\abc
                              vlfx e:abc

          "Invalid filename in (stamp, date, time) filter"
                    The filename given as the implied date or time value
               contains an illegal character.  Check whether you have
               omitted the closing quotes to end the filename.
                    Examples: vlfx /fstamp "fil+000"
                              vlfx /FD "fil0000/v

          "Invalid modifier in (stamp, date, time) filter"
                    The date or time value modifier is too large.  The
               date modifier cannot create a date prior to 0-00-80 nor
               later than 12-31-2099.  The time modifier cannot be greater
               than one day (1440 minutes).
                    Examples: vlfx/FD eq today - 4000 (prior to 1980)
                              vlfx/FD eq today + 45000 (beyond 2099)
                              vlfx/fT eq 08:10:20 + 1441 (more than 1 day)

          "Invalid option"
                         During the scan of the command line, a "/" was
               found that was followed by a character not recognized as an
               option.
                    Examples: vlf /s/y fil0000.

          "Invalid size in size filter"
                    The size value is either not numeric or is too large.
                    Examples: vlfx /f si eq 4294967296
                              vlfx/fsi fil0000.

          "Missing modifier in (stamp, date, time) filter"
                    The date or time value is followed by a plus (+) or
               minus (-) but no numeric modifier.
                    Examples: vlfx /f (stam eq today - AND si 1000)
                              vlfx /f d eq today -/x

          "Missing separator in filter"
                    While scanning the Filter option, VLFX expected to
               find a valid separator, but instead found a text character.
                    Examples: vlfx/FD eq 01-01-87-20-20 (too many fields)
                              vlfx/FD eq 01.40.87 (wrong separator)

          "Missing value in (name, size, etc.) filter"
                    While scanning a recognized condition, VLFX was unable
               to find a valid value field before either the end of the
               command line or the end of the expression.
                    Examples: vlfx fil*. /f si
                              vlfx fil*. /f si  eq/x
                              vlfx fil*. /f( si  eq /x)


                                  --- Page 30 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

          "Need DOS version 2.00 or greater" (Std Out)
                         The version number returned by the operating
               system is lower than 2.00.  No corrective action is
               possible.  VLF has exited without taking any action.

          "No files matching "filename.ext" (and filter)" (Std Out)
                    VLF was unable to find any matching files in the
               directories specified.  If you specified a filter, that
               notation is added, to indicate that even though there may
               have been files matching the filespec, none passed the
               filter.  If "filename.ext" is not the filespec you
               intended, the error is really something else on the command
               that causes VLF to mistake the filespec.

          "No opening quotes for pattern in name filter"
                    In the place where VLFX expected to find a regular
               expression enclosed in double-quote characters ("), it
               found an initial character that was not a double-quote.
                    Examples: vlfx /ff  abc"
                              vlfx /ff  \"abc

          "No volume label" (Std Out)
                    This disk does not have a label entry in the root
               directory.

          "Null pattern in name filter"
                    The regular expression in the name filter appears to
               VLFX as a null pattern.
                    Examples: vlfx /ff ""

          "**Read error in DR:\PATH\FILENAME.ZIP" (Std Out)
                    There was a read error while searching the named
               archive file.  VLFX closed the file and went on to the next
               file.  Appears only if you respond "i" to the "Abort,
               Retry, Ignore?" request from DOS.

          "**Read error on drive X"
                    While reading the disk to get the information required
               by the /X and /L options, DOS returned an error.  Try
               again; if the error persists, there may be damage to the
               disk.

          "Strike any key to continue ..."
                    With the /P option on, VLF inserts this message every
               24 lines and waits for you to press any key.  The keyboard
               buffer is flushed first, so that you can't accidentally go
               past a screenful (by hitting a function key in response to
               the last pause message, for example).






                                  --- Page 31 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

          "Unexpected end in filter"
                    While scanning the Filter option, VLFX got to the end
               of the command line before it had closed all the open
               parentheses for filter conditions.
                    Examples: vlfx/f NOT (si gt 200 si lt 4000
                              vlfx/f (NOT (si gt 200), (si lt 4000)

          "Unexpected end in (stamp, date, time) filter"
                    While scanning the filespec of an implied date or time
               value, VLFX came upon the end of the command line before
               the end of the filespec.
                    Examples: vlfx /f d "fil0000
                              vlfx /f (d "fil0000)

          "Unexpected end of pattern (in character set) in name filter"
                    The end of the command line came before the closing
               character, either double-quote (") or right-bracket (]).
                    Examples: vlfx /ff     "abc /x
                              vlfx /ff     "abc[\"]
                              vlfx /ff     "abc[abc"]
                              vlfx /ff     "abc\"

          "Unmatched brackets in character set in name filter"
                    While scanning a character set, VLFX was unable to
               find a closing bracket (]) before the end of the pattern.
                    Examples: vlfx /ff  "abc[def"
                              vlfx /ff  "abc[def\]"
                              vlfx /ff  "abc[]def"
                              vlfx /ff  "[0-]"

          "Unmatched parenthesis in name filter"
                    While scanning a pattern group, VLFX was unable to
               find a closing parenthesis ()) before the end of the
               pattern.
                    Examples: vlfx /ff  "a(b(cd)"
                              vlfx /ff  "a(b(cd)\)"

          "**User terminated**" (Std Out)
                    VLF was interrupted by the Control-Break/Control-C
               key.  VLF stopped as soon as it could; the display may have
               run on for several lines because VLF disables the Break
               interrupt during the display of its print buffer.












                                  --- Page 32 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

                                     SECTION 7

                            Restrictions, Limits, Hints
                            ---------------------------

               Because an Extended Search (E) has to look at each filename
          in the directory to see whether it is an archive and then
          examine the contents of each archive, it is slower than the
          regular file search.

               The /X and /L options can read disk sectors of up to 4096
          bytes and a File Allocation Table (FAT) of up to 32768 bytes
          (16536 16-bit entries).  No check is made is made on these
          limits, so the results will be unpredictable (but bad) if they
          are exceeded.  If the logical format of the disk is otherwise
          standard, modifications to the sector and cluster sizes should
          not affect /X so long as the disk parameters are kept consistent
          in DOS, the limits above are not exceeded and the number of
          sectors per cluster is a power of two.  Since DOS 4.xx creates a
          disk partition greater than 32MB by extending the FAT more than
          32K and changing internal tables, /X and /L cannot now be used
          on such a partition.  The popular MEMBRAIN program seems to
          allow three or five sectors per cluster for its RAM disk; you
          cannot use /X or /L on such a disk.  /X and /L cannot handle
          non-standard FAT configurations at all.

               The search functions, including /F, are usable on drives
          "reassigned" with ASSIGN or JOIN or SUBST, but /A will list
          duplications where a physical drive is known by two or more
          identifiers.  For example, if Drive A: is assigned to Drive C:
          with "ASSIGN a=c", any file found on C: will also be listed for
          A:.  The exception is that logical Drive B: is always skipped if
          there is no physical drive present; this is to avoid listing
          Drive A: a second time in the usual XT and AT configurations.

               The drive specifier is assumed to be one of the 26 letters
          in the English alphabet.  The path, of course, is normally
          limited to 64 bytes, a restriction imposed by DOS.

               VLF memory allocation (and DOS) assumes that there will be
          no more than 32 directory levels.  Like all applications, VLF
          becomes a little fragile at the limits of the operating system.
          Even though the SPECIFIED path may not exceed 64 bytes, it is
          possible both to create and remove subdirectories beyond the
          thirty-second level (but you cannot make any of them the current
          directory).  If your disk has more than 32 levels, VLF may be
          able to reach all of them with /V or /S, provided the total
          length of the filespec (drive, path, filename, extension) does
          not exceed 92 bytes.

               If the file size field in the directory contains a value
          greater than 9 decimal digits, only the rightmost 9 digits are
          displayed.

                                  --- Page 33 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------


               The counters for total number of files displayed and
          clusters are limited to 64K, so if your listing exceeds that
          limit, the system totals will be modulo 64K.  Similarly, the
          display of cumulative totals for file sizes are limited to 9
          digits.

               VLF knows nothing about monitors or colors.  It assumes
          that the standard output device is 25 lines by 80 columns and is
          in text mode.  A wider screen should not cause a problem, but
          the displays on a narrower screen will obviously run over, and
          pause line counts will be off.

               VLF is among the best behaved of programs.  It does not
          read or write the video buffer directly and with one exception,
          uses only DOS services (VLF uses BIOS Interrupt 11h to check the
          number of physical floppy drives when /A is specified).  All
          screen displays are done via the standard output device and the
          standard error device, permitting fully redirected output for
          everything except error messages.  VLF does use several
          unpublished DOS services and fields; however, all have been
          tested for consistency with all PC-DOS versions from 2.0 through
          3.21.  VLF has not been tested on any other versions, nor on any
          other brands of operating systems, although it seems certain
          that /X and /L cannot now be used on DOS 4.xx partitions larger
          than 32 megabytes.

               DOS Interrupt 25h is used extensively in /X and /L
          processing; any device driver that does not implement Interrupt
          25h will not support those options.  This includes most, if not
          all, network devices.

               You can break out of a long listing with Control-Break or
          Control-C.  If Control-C doesn't respond, try adding "BREAK=ON"
          to your CONFIG.SYS file.

               In order to speed up the screen display and still allow a
          quick break-out from a long display, the standard output device
          is set to binary, or "raw", output -- that is, it does not check
          for Control-Break after each character is delivered to the
          screen -- and the BREAK state is set to ON.  There are two
          consequences: first, at a break VLF will not stop displaying
          until it has emptied its print buffer; second, if VLF is
          terminated other than with the Control-Break/Control-C key, it
          never gets a chance to restore the settings to their original
          values.  You can use IOCTL to reset the mode ("IOCTL OUTPUT
          ASCII" sets the standard output device to ASCII mode; check the
          current setting with "IOCTL output").  The BREAK state can be
          reset with the DOS Break command (BREAK OFF sets the state to
          off; "BREAK" checks the status).  There are some OEM versions of
          DOS that don't seem to handle binary mode standard output (some
          Zenith DOS versions, for example); to avoid adding another


                                  --- Page 34 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

          option for what are uncommon systems, no switch is provided to
          turn off binary mode, but we will make individual arrangements
          if you contact us.

               If you redirect VLF output with a search pattern that
          includes the output file, that file's size and its cluster chain
          will both be zero.  The reason is that the output file is still
          open, so its directory entries have not been filled in.  Because
          the file size is still zero, VLF will not attempt to display
          that file's contents when the /L option is on.  Note also that,
          when redirected, the message giving the number of bytes
          available on disk will not necessarily be accurate as of the end
          of the run because output is still being created when that
          number is calculated.








































                                  --- Page 35 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

                                     SECTION 8

                     Technical Information and Revision History
                     ------------------------------------------

               VLF/VLFX is written entirely in assembly language.  The
          most recent version has been compiled with Microsoft MASM
          version 5.1 and linked with Microsoft Overlay Linker version
          3.64.  All English language displays and messages are contained
          in a separate module that we will make available for translation
          if you prefer a customized VLF in another language.

          Version 1.00   July 17, 1986

          Version 2.01   December 16, 1987
               Fixed LOOK; changed /V to ignore path; added /S; /A tests
          each floppy for availability; std output device set to binary
          mode
               Reduced print buffer to 512B to allow quicker termination
          on Ctrl-Break; moved "free disk space" routine to end
               All error messages sent to std err device; Break set on and
          Ctrl-Break interrupt taken over; dot entries handled correctly
               Split into Standard (VLF) and Extended (VLFX) versions;
          added efficiency statistics
               Added FILTER; changed year to 4 digits in EXPAND mode
               Set date format to YYYY-MM-DD in Expand; added drive ID to
          volume heading; fixed bug in handling 64 byte paths; added
          volume totals; excluded subdirs from efficiency calculation;
          various cosmetic changes to display; added error message for
          invalid path; added filter notation to "no match" message; pause
          message sent to std err; fixed bug in Look EOL count

          Version 3.10   September 28, 1988
               Fixed bug in filter date modifier; file sizes over 655M
          truncated to rightmost 9 digits; slight improvements in code
          organization; ASSIGNed, JOINed and SUBSTituted drives handled
          correctly by /X & /L & /A.
               Minor code reorganization to remove or disguise long fields
          of uninitialized variables.
               Extended /W to permit 1-5 file entries per display line;
          fixed bug that hung system when >64-character path specified by
          user or found on disk with /S and /V; minor code improvements in
          processing filespec.
               Added ARCfile search to VLFX; added initial purge of DOS
          disk buffers to force new read where disk has been changed.
               Added /E switch to make archive search optional.

          Version 3.20   February 18, 1989
               Added ZIPfile search to VLFX; changed drive availability
          test to use critical error timeout on request for current
          directory instead of Interrupt 25 read (does not cause DOS to
          recompute free space on each run and prevents confusion of
          subdirectories when changing disks).

                                  --- Page 36 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

                                     SECTION 9

                                 License and Rights
                                 -----------------

               VLF.COM, VLFX.COM, and all other programs and documentation
          included in this package are Copyright 1986,1987,1988,1989 by
          Software Appliances, are published by and are the property of
          the author Robin A. Reyes, dba Software Appliances, 52 Bingham
          Avenue, Dedham, Mass. 02026.  Except as explicitly granted in
          this license, all rights are reserved to the author.

               You are free to use, copy and distribute VLF, VLFX and any
          other programs and documentation included in this package for
          noncommercial use PROVIDED THAT:

               1. You do not charge a fee for their use, nor for their
               copying or distribution, and

               2. You copy or distribute all programs and documentation
               included in this package together, unmodified in any way.
               It is preferable that you to copy and distribute the
               original archive, and

               3. You do not include or incorporate the programs or
               documentation or facsimiles with any offering of goods or
               services for profit.

               Not-for-profit clubs and user groups may charge a nominal
          fee (less than $8) sufficient to cover expenses and handling in
          distributing this program package, with written permission from
          the author at the address below.

               "Noncommercial use" means that you do not use the programs
          in your work.  Commercial users, however, may use the programs
          for up to 10 days, as a trial.  Commercial licenses for VLF and
          VLFX are available from the author at the address below.

               THESE PROGRAMS AND DOCUMENTATION ARE PROVIDED AS IS WITHOUT
          ANY WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO
          ANY WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
          PURPOSE.  By using these programs and documentation voluntarily,
          you agree that the author is not liable to you for any damages,
          including lost profits or other incidental or consequential
          damages arising out of the use of the programs or documentation.

               If you use VLF or VLFX regularly, a contribution of $15 or
          more would be appreciated.  With each contribution of US $25 or
          more you will be registered to receive a diskette with the next
          version of VLF and VLFX if, as and when available.  Please state
          the version of the programs that you have.



                                  --- Page 37 ---




                             VLF - LIST FILES Version 3
          ----------------------------------------------------------------

          Send your contribution or registration to:

               Robin A. Reyes
               Software Appliances
               52 Bingham Avenue
               Dedham, Massachusetts 02026

          Call for help:  All software is quirky; software designed and
          implemented by one person is more quirky than most.  Please help
          with your comments, gripes, wish-lists, etc., but remember the
          purpose of VLF/VLFX is to be small, fast, and rich at the
          command-line.

          "IBM", "Intel", "Microsoft", and "Zenith" are claimed as
          trademarks by International Business Machines Corporation, Intel
          Corporation, Microsoft Corporation, and Zenith Data Systems,
          respectively.





































                                  --- Page 38 ---


         ----------------end-of-author's-documentation---------------

                        Software Library Information:

                   This disk copy provided as a service of

                        The Public (Software) Library

         We are not the authors of this program, nor are we associated
         with the author in any way other than as a distributor of the
         program in accordance with the author's terms of distribution.

         Please direct shareware payments and specific questions about
         this program to the author of the program, whose name appears
         elsewhere in  this documentation. If you have trouble getting
         in touch with the author,  we will do whatever we can to help
         you with your questions. All programs have been tested and do
         run.  To report problems,  please use the form that is in the
         file PROBLEM.DOC on many of our disks or in other written for-
         mat with screen printouts, if possible.  The P(s)L cannot de-
         bug programs over the telephone.

         Disks in the P(s)L are updated monthly, so if you did not get
         this disk  directly from the P(s)L,  you should be aware that
         the files in this set may no  longer be the current versions.

         For a copy of the latest monthly software library newsletter
         and a list of the 1,800+ disks in the library, call or write

                        The Public (Software) Library
                              P.O.Box 35705 - F
                           Houston, TX 77235-5705
                               (713) 665-7017

